pins = { -- ноги
    open = 7, -- открытие крана
    close = 6, -- закрытие крана
    ledOpen = 2 -- светодиод
}

data = { -- состояние устройства
    false, -- isOpen
    false, -- isWater 
    true,  -- work 
	"valve", -- а это название параметров, кран
	"watering", -- в режиме включения через 3 часа
	"working" -- блокировано/не блокировано
}

for _, pin in pairs(pins) do -- объявлем пины как выходы и выставляем
    gpio.mode(pin, gpio.OUTPUT)
    gpio.write(pin, gpio.HIGH)
end
gpio.write(pins.ledOpen, gpio.LOW) -- отдельно пин светодиода в ноль

Broker="ВАШ_САЙТ"
port=ВАШ_ПОРТ
myClient="garden"
pass="pass"
publish = false
count = 1

m = mqtt.Client(myClient, 180, myClient, pass)
m:lwt("/lwt", myClient, 0, 0)

-- эту функцию я уже описывал
function connecting() -- функция установления и поддержания связи с брокером
    publish = false -- нет связи - нет публикации
    local function getConnect()  -- сам коннект непосредственно  
       if wifi.sta.status() == 5 and wifi.sta.getip() ~= nil then 
            m:connect(Broker, port, 0, 0,
                function(conn)
                    publish = true
                    tmr.stop(3)
                    tmr.unregister(3)
                    m:subscribe(myClient.."/#",0, function(conn)
                    end)
            end)    
        end
    end
    getConnect() 
    tmr.alarm(3, 90000, 1, function()
        getConnect()
    end)
end

m:on("offline", function(con)
    publish = false
    connecting()
end)

function pM() -- обертка-функция публикаии на MQTT
	local count = 1 --  считаем что надо публиковать вместе с немедленной публикацией
	local tt, mm 
	local pubb = function(mess, topic) -- непосредственная публикация
		if publish == true then -- если можно публиковать
			topic = topic or "valve" -- данные о кране можно публиковать и без указания на него
			m:publish(myClient.."/"..topic.."/state",mess,0,0) -- пуликация немедленных данных
			mm = data[count] -- берем состояние из таблицы в соответствии со счетчиком 
			if mm == false then mm = "OFF" else mm = "ON" end  
			tt = data[count + 3] -- берем данные из таблицы + 3, это название данных
			count = count + 1 -- увеличиваем счетчик 
			if count == 4 then count = 1 end -- или выставляем на начало
			m:publish(myClient.."/"..tt.."/state",mm,0,0) -- публикуем данные из таблицы
		end
	end
	return pubb -- возвращается функция для передачи в нее данных 
end
 
pubMess = pM() -- вход в публикацию

m:on("message", function(conn, topic, dt) -- разбор указаний от MQTT брокера
	if (string.find(topic, "state")) == nil then 
        local top = string.gsub(topic, myClient.."/","") 
        print(top..":"..dt) 
        if top == "vl" then -- это кран
            if dt == "ON" then
                turnOn(pins.open)
            else
                turnOn(pins.close)
            end
        end
        if top == "gr" then -- это общее разрешение работы устройства
            if dt == "ON" then
                data[3] = true
				data[2] = false
                print('work = true')
                pubMess("ON", "working")
            else
                data[3] = false
                print('work = false')
                pubMess("OFF","working")
				tmr.stop(5)
				turnOn(pins.close)
            end
        end
    end
    collectgarbage() 
end)

function debounce (func) -- устранение дребезга кнопки
    local last = 0
    local delay = 60000

    return function (...) -- сразу выполняет передаваемую функцию
        local now = tmr.now()  -- а потом 60 mc ничего не делает
        if now - last < delay then 
          return 
        end

        last = now
        return func(...)
    end
end

function onChange () -- функция, которая передается для выполнения антидребезгу
    if  gpio.read(1) == 0  then -- если кнопка в нуле
            if data[1] == true then -- включено - выключаем
                turnOn(pins.close)
            else
                turnOn(pins.open) -- иначе включаем
            end
    end
end

function turnOn(pin) -- работаем с ногами шарового крана 
    tmr.stop(1) -- при обращении к функции все сбрасываем
    gpio.write(pins.open, gpio.HIGH)
    gpio.write(pins.close, gpio.HIGH)
    
    gpio.write(pin, gpio.LOW) -- и пишем в ту ногу, которую передали в функцию
    print('Power ON pin '..pin)
    
    tmr.alarm(1, 30000, tmr.ALARM_SINGLE, function() -- запускаем таймер на снятие питания 
        gpio.write(pin, gpio.HIGH) -- с полученной ноги через 30 секунд. Потому что крану
        print("Power OFF from 30 sec. pin "..pin) -- надо 21 секунду чтобы полностью открыться 
    end) -- или закрыться
    
    if pin == pins.open then -- разбираемся что за пин мы обработали, если на откртие
        data[1] = true -- пишем в таблицу что кран открыли
        pubMess("ON") -- публикуем инфо об этом
        gpio.write(pins.ledOpen, gpio.HIGH) -- зажигаем светодиод
        print("Valve is open")
        tmr.alarm(2, 2700000, tmr.ALARM_SINGLE, function() -- выставляем таймер чтобы звкрыть через 
            print("Time to Close by Time") -- 45 минут
            turnOn(pins.close)
        end)
    else -- если нога на закрытие
        pubMess("OFF") -- публикуем
        tmr.stop(2) -- тормозим таймер закрытия
        gpio.write(pins.ledOpen, gpio.LOW) -- гасим светодиод
        print("Valve is closed")
        data[1] = false -- пишем в таблицу что кран закрыт
    end
end

function delayStart() -- отложенный старт на 3 часа
    local counter = 0 -- локальный счетчик часов 
    tmr.alarm(5, 3600000, tmr.ALARM_AUTO, function() -- таймер на час 
        counter = counter + 1 -- считаем часы
        if counter > 3 then -- запускаем включение крана
			counter = 0
            tmr.stop(5)
            tmr.unregister(5)
			if data[3] then turnOn(pins.open) end -- но если устройству разрешено работать
        end
    end)
end


tmr.alarm(4, 10000, tmr.ALARM_AUTO, function() -- проверяем освещенность
    local light = adc.read(0) -- читаем датчик
    print("Light: ", light)
    pubMess(light, "light") -- публикуем датчик
	-- если темно, не установлен таймер запуска и устройству разрешено работать	
    if light > 1020 and data[2] == false and data[3] == true then
        pubMess("OFF", "day") -- публикуем что ночь
        data[2] = true -- устанавливаем что приступили к работе
		print("delayStart")
        delayStart() -- вызываем наполнение бочки с задержкой
    end
    if light < 350 and data[2] == true then -- а это - день
        data[2] = false -- не полито
        print('Day now!')
        pubMess("ON", "day") -- говорим что день
    end 
end)

gpio.mode(1, gpio.INT) -- прерывание на ноге кнопки
gpio.trig(1, 'down', debounce(onChange)) -- по спаду вызываем функцию debounce и передаем ей onChange

connecting() -- поехали!
